/* ternasm.c */

mova_baixo_asm (int attrib)
{
  asm  Push  ES
  asm  Push  DS
  asm  Push  DI
  asm  Push  SI
  asm  Push  AX
  asm  Push  DX
  asm  Push  CX
  asm  Mov   AX,0B800H
  asm  Mov   DS,AX
  asm  Mov   SI,(80*2)*22+(79*2)
  asm  Mov   ES,AX
  asm  Mov   DI,(80*2)*23+(79*2)
  asm  Mov   CX,80*23
  asm  std
  asm  Rep   MovSW            /* Move a janela para baixo */
  asm  Mov   CX,80
  asm  Mov   AH,attrib
  asm  Mov   AL,20H
  asm  Mov   DI,0
  asm  cld
  asm  Rep   StoSW            /* Limpa a primeira linha */
  asm  Pop   CX
  asm  Pop   DX
  asm  Pop   AX
  asm  Pop   SI
  asm  Pop   DI
  asm  Pop   DS
  asm  Pop   ES
}

mova_cima_asm (int attrib)
{
  asm  Push  ES
  asm  Push  DS
  asm  Push  DI
  asm  Push  SI
  asm  Push  AX
  asm  Push  DX
  asm  Push  CX
  asm  Mov   AX,0B800H
  asm  Mov   DS,AX
  asm  Mov   SI,80*2
  asm  Mov   ES,AX
  asm  Mov   DI,0
  asm  Mov   CX,80*23
  asm  cld
  asm  Rep   MovSW            /* Move a janela para baixo */
  asm  Mov   CX,80
  asm  Mov   AH,attrib
  asm  Mov   AL,20H
  asm  Mov   DI,(80*2)*23
  asm  cld
  asm  Rep   StoSW            /* Limpa a primeira linha */
  asm  Pop   CX
  asm  Pop   DX
  asm  Pop   AX
  asm  Pop   SI
  asm  Pop   DI
  asm  Pop   DS
  asm  Pop   ES
}

clrscr_asm ()
{
  asm  Push  ES
  asm  Push  DI
  asm  Push  AX
  asm  Push  CX
  asm  Mov   AX,0B800H
  asm  Mov   ES,AX
  asm  Mov   DI,0
  asm  Mov   CX,80*24
  asm  Mov   AX,00720h
  asm  cld
  asm  Rep   StoSW            /* Lima a janela */
  asm  Pop   CX
  asm  Pop   AX
  asm  Pop   DI
  asm  Pop   ES
  gotoxy (1, 1);
}

receive_asm (int character, int attrib)
{
  asm  Push  AX
  asm  Push  BX
  asm  Push  CX

  asm  Mov   AX,character
  asm  Cmp   AX,32              /* Caracter nao especial */
  asm  Jge   Normal

  asm  Cmp   AX,27              /* ESC */
  asm  Jne   NaoESC

  asm  Pop   CX
  asm  Pop   BX
  asm  Pop   AX
  receive_command (character);
  asm  Jmp   Sair

NaoESC:
  asm  Cmp   AX,13              /* CR */
  asm  Jne   NaoCR
  asm  Mov   AH,3
  asm  Mov   BH,0
  asm  Int   10h
  asm  Mov   DL,0
  asm  Mov   AH,2
  asm  Int   10h
  asm  Jmp   Fim

NaoCR:
  asm  Cmp   AX,10              /* LF */
  asm  Je    Linefeed

  asm  Pop   CX
  asm  Pop   BX
  asm  Pop   AX
  receive_command (character);
  asm  Jmp   Sair

Linefeed:
  asm  Mov   AH,3
  asm  Mov   BH,0
  asm  Int   10h
  asm  Inc   DH
  asm  Cmp   DH,23
  asm  Jle   Continue
  asm  Mov   AH,2
  asm  Dec   DH
  asm  Int   10h
  asm  Pop   CX
  asm  Pop   BX
  asm  Pop   AX
  mova_cima_asm (attrib);
  asm  Jmp   Sair

Continue:
  asm  Mov   AH,2
  asm  Int   10h
  asm  Jmp   Fim

Normal:
  asm  Mov   AH,9
  asm  Mov   AL,character
  asm  Mov   BH,0
  asm  Mov   BL,attrib
  asm  Mov   CX,1
  asm  Int   10h
  asm  Mov   AH,3
  asm  Mov   BH,0
  asm  Int   10h
  asm  Inc   DL
  asm  Cmp   DL,80
  asm  Jne   Sete
  asm  Mov   DL,0
  asm  Inc   DH
  asm  Cmp   DH,23
  asm  Jle   Sete
  asm  Mov   AH,2
  asm  Dec   DH
  asm  Int   10h
  asm  Pop   CX
  asm  Pop   BX
  asm  Pop   AX
  mova_cima_asm (attrib);
  asm  Jmp   Sair

Sete:
  asm  Mov   AH,2
  asm  Int   10h   /* Seta cursor */

Fim:
  asm  Pop   CX
  asm  Pop   BX
  asm  Pop   AX
Sair:
;
}
