/* ----------- keys.h ------------ */

#define RUBOUT    8
#define BELL 	    7
#define ESC       27

#define F1        187
#define F2        188
#define F3        189
#define F4        190
#define F5        191
#define F6        192
#define F7        193
#define F8        194
#define F9        195
#define F10       196

#define CTRL_F1   222
#define CTRL_F2   223
#define CTRL_F3   224
#define CTRL_F4   225
#define CTRL_F5   226
#define CTRL_F6   227
#define CTRL_F7   228
#define CTRL_F8   229
#define CTRL_F9   230
#define CTRL_F10  231

#define ALT_F1    232
#define ALT_F2    233
#define ALT_F3    234
#define ALT_F4    235
#define ALT_F5    236
#define ALT_F6    237
#define ALT_F7    238
#define ALT_F8    239
#define ALT_F9    240
#define ALT_F10   241

#define HOME      199
#define UP        200
#define PGUP      201
#define BS        203
#define FIVE      204		/* non-BIOS keystroke value */
#define FWD       205
#define END       207
#define DN        208
#define PGDN      209
#define INS       210
#define DEL       211

#define CTRL_HOME 247
#define CTRL_UP   141		/* non-BIOS keystroke value */
#define CTRL_PGUP 132
#define CTRL_BS   243
#define CTRL_FIVE 143
#define CTRL_FWD  244
#define CTRL_END  245
#define CTRL_DN	  145		/* non-BIOS keystroke value */
#define CTRL_PGDN 246
#define CTRL_INS  146		/* non-BIOS keystroke value */
#define CTRL_DEL  147		/* non-BIOS keystroke value */

#define ALT_HOME  151		/* non-BIOS keystroke value */
#define ALT_UP	  152		/* non-BIOS keystroke value */
#define ALT_PGUP  153		/* non-BIOS keystroke value */
#define ALT_BS	  155		/* non-BIOS keystroke value */
#define ALT_FIVE  156		/* non-BIOS keystroke value */
#define ALT_FWD	  157		/* non-BIOS keystroke value */
#define ALT_END	  159		/* non-BIOS keystroke value */
#define ALT_DN	  160		/* non-BIOS keystroke value */
#define ALT_PGDN  161		/* non-BIOS keystroke value */
#define ALT_INS	  162		/* non-BIOS keystroke value */
#define ALT_DEL	  163		/* non-BIOS keystroke value */

int getkey(void);
void autotype(char *);
void repeat_rate(int);
void stuffkey(int);
void clear_biosbuff(void);

extern int cgets_returnkey;
